type AnyFn = (...args: any[]) => any;
type InstrumentFunction = <X extends AnyFn>(name: string, fn: X) => X;

type Provider<Provide, Input = unknown> = (() => Provide | Promise<Provide>) | ((input: Input) => Provide | Promise<Provide>);
type ProviderOption = {
    instrument?: InstrumentFunction;
};
declare const defaultProviderOptions: ProviderOption;
type Executor<Provide> = {
    execute(): Promise<Provide>;
};
declare function create<Provide, Dependent = unknown>(provider: Provider<Provide, Dependent>, dependent?: Executor<Dependent>, options?: ProviderOption): {
    execute: () => Promise<Provide>;
};
declare const createProvider: <Output, Input>(provider: Provider<Output, Input>) => Provider<Output, Input>;
declare const value: <Provide>(value: Provide) => {
    execute: () => Promise<Provide>;
};
declare const from: <Dependent>(executor: Executor<Dependent>) => {
    provide: <Provide>(provider: Provider<Provide, Dependent>) => {
        execute: () => Promise<Provide>;
    };
    execute: (executable: (Dependent: Dependent) => any) => Promise<any>;
};
type inferProvide<T> = T extends Executor<infer S> ? S : never;
declare const combine: <L extends Record<string, Executor<any>>>(layout: L) => Executor<{ [key in keyof L]: inferProvide<L[key]>; }>;

export { Executor, ProviderOption, combine, create, createProvider, defaultProviderOptions, from, inferProvide, value };
